/*
 * This file is part of OpenModelica.
 *
 * Copyright (c) 1998-CurrentYear, Open Source Modelica Consortium (OSMC),
 * c/o Linkpings universitet, Department of Computer and Information Science,
 * SE-58183 Linkping, Sweden.
 *
 * All rights reserved.
 *
 * THIS PROGRAM IS PROVIDED UNDER THE TERMS OF GPL VERSION 3 LICENSE OR 
 * THIS OSMC PUBLIC LICENSE (OSMC-PL). 
 * ANY USE, REPRODUCTION OR DISTRIBUTION OF THIS PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE
 * OF THE OSMC PUBLIC LICENSE OR THE GPL VERSION 3, ACCORDING TO RECIPIENTS CHOICE. 
 *
 * The OpenModelica software and the Open Source Modelica
 * Consortium (OSMC) Public License (OSMC-PL) are obtained
 * from OSMC, either from the above address,
 * from the URLs: http://www.ida.liu.se/projects/OpenModelica or  
 * http://www.openmodelica.org, and in the OpenModelica distribution. 
 * GNU version 3 is obtained from: http://www.gnu.org/copyleft/gpl.html.
 *
 * This program is distributed WITHOUT ANY WARRANTY; without
 * even the implied warranty of  MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE, EXCEPT AS EXPRESSLY SET FORTH
 * IN THE BY RECIPIENT SELECTED SUBSIDIARY LICENSE CONDITIONS OF OSMC-PL.
 *
 * See the full OSMC Public License conditions for more details.
 *
 * Main author: Wladimir Schamai, EADS Innovation Works / Linkping University, 2009-now
 *
 * Contributors: 
 *   Uwe Pohlmann, University of Paderborn 2009-2010, contribution to the Modelica code generation for state machine behavior, contribution to Papyrus GUI adoptations
 *   Parham Vasaiely, EADS Innovation Works / Hamburg University of Applied Sciences 2009-2011, implementation of simulation plugins
 */
package org.openmodelica.modelicaml.simulation.omc.corba;



// TODO: Auto-generated Javadoc
/**
* OmcCommunicationHolder.java .
* Generated by the IDL-to-Java compiler (portable), version "3.2"
* from omc_communication.idl
* Thursday, October 27, 2005 10:11:20 AM CEST
*/


// As simple as can be omc communication, sending and recieving of strings.
public final class OmcCommunicationHolder implements org.omg.CORBA.portable.Streamable
{
  
  /** The value. */
  public OmcCommunication value = null;

  /**
   * Instantiates a new omc communication holder.
   */
  public OmcCommunicationHolder ()
  {
  }

  /**
   * Instantiates a new omc communication holder.
   *
   * @param initialValue the initial value
   */
  public OmcCommunicationHolder (OmcCommunication initialValue)
  {
    value = initialValue;
  }

  /* (non-Javadoc)
   * @see org.omg.CORBA.portable.Streamable#_read(org.omg.CORBA.portable.InputStream)
   */
  public void _read (org.omg.CORBA.portable.InputStream i)
  {
    value = OmcCommunicationHelper.read (i);
  }

  /* (non-Javadoc)
   * @see org.omg.CORBA.portable.Streamable#_write(org.omg.CORBA.portable.OutputStream)
   */
  public void _write (org.omg.CORBA.portable.OutputStream o)
  {
    OmcCommunicationHelper.write (o, value);
  }

  /* (non-Javadoc)
   * @see org.omg.CORBA.portable.Streamable#_type()
   */
  public org.omg.CORBA.TypeCode _type ()
  {
    return OmcCommunicationHelper.type ();
  }

}
